6.33   os16: fgets(3)

NOME

    fgets, gets - lettura di una stringa da un flusso di file

SINTASSI

    #include <stdio.h>
    char *fgets (char *restrict <string>, int <n>, FILE *restrict <fp>);
    char *gets  (char *<string>);

DESCRIZIONE

    La funzione <fgets()> legge una "riga" dal flusso di file <fp>, purche' non
    piu` lunga di <n>-1 caratteri, collocandola a partire da cio` a cui punta
    <stringa>. La lettura termina al raggiungimento del carattere \n (new line
    ), oppure alla fine del file, oppure a <n>-1 caratteri. In ogni caso, viene
    aggiunto al termine, il codice nullo di terminazione di stringa: \0.

    La funzione <gets()>, in modo analogo a <fgets()>, legge una riga dallo
    standard input, ma senza poter porre un limite massimo alla lunghezza della
    lettura.

VALORE RESTITUITO

    In caso di successo, viene restituito il puntatore alla stringa contenente
    la riga letta, ovvero restituiscono <string>. In caso di errore, o comunque
    in caso di una lettura nulla, si ottiene NULL. La variabile <errno> viene
    aggiornata solo se si presenta un errore di accesso al file, mentre una
    lettura nulla, perche' il flusso si e` concluso, non comporta tale
    aggiornamento.

ERRORI

    La variabile <errno> potrebbe risultare aggiornata nel caso le funzioni
    restituiscano NULL. Ma per saperlo, occorre azzerare la variabile <errno>
    prima della chiamata di queste.

    Valore
    di      Significato
    <errno>
    EBADF   Il descrittore di file associato al flusso da cui leggere un
            carattere, non e` valido.
    EINVAL  Il descrittore di file associato al flusso da cui leggere un
            carattere, non consente un accesso in lettura.

FILE SORGENTI

    lib/stdio.h [13.9]

    lib/stdio/fgets.c [13.9.9]

    lib/stdio/gets.c [13.9.25]

VEDERE ANCHE

    fgetc(3) [6.31], getc(3) [6.31].

